/***************************************************************************
 *   Copyright (C) 2005 by Johan Alfred Baron de Brtu                     *
 *   Bretu@Bruno                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

class Flakes
{
private:
	static int width, height, nb;
	static float m_speed;
	int translate, trans_count;
 	float x,y, phi;
	int size;
public:
	Flakes();
	~Flakes();
	static float fall;
	void Move();
	void Draw();
	static void SetScreenSize(int width, int height);
	static void SetSpeed(float speed);
	static void ModSpeed(bool dir);
};

int Flakes::width = 800;
int Flakes::height = 600;
int Flakes::nb = 0;

float Flakes::m_speed = 0.01;
float Flakes::fall = 0.0;

Flakes::Flakes()
{
	x = (float)(rand()%Flakes::width)/(float)Flakes::width*2.0-1.0;
	y = (float)(rand()%Flakes::height)/(float)Flakes::height*2.0-1.0;
	size = rand()%3;
	phi = rand()*3.1415926535897932384626/RAND_MAX;
	translate = rand()%3-1;
	trans_count = rand()%10;
	nb++;
}

Flakes::~ Flakes()
{
	nb--;
}

void Flakes::Move()
{
	y -= Flakes::m_speed;
	if(y < -1.0)
		y += 2.0;
	/*if(trans_count)
	{
		x += (float)translate/(float)Flakes::width/6.0;
	
		trans_count--;
	}
	else
	{
		translate = rand()%3-1;
		trans_count = rand()%10;
	}*/
	x += cosf(fall + phi)/(float)Flakes::width*2.0;
// 	x += (float)(rand()%3-1)/float(Flakes::width);
}

void Flakes::Draw()
{
	glVertex3f(x,y,0.0);
}

void Flakes::SetScreenSize(int width, int height)
{
	Flakes::width = width;
	Flakes::height = height;
}

void Flakes::SetSpeed(float speed)
{
	Flakes::m_speed = speed;
}

void Flakes::ModSpeed(bool dir)
{
	if(dir)
		Flakes::m_speed += 0.0001;
	else
		Flakes::m_speed -= 0.0001;
}

class Neige
{
private:
	int nb;
	Flakes** flocons;
public:
	void Draw();
	void Fall();
	void Add(int nombre);
	void Remove(int nombre);
	Neige(int nombre, int width, int height, float speed);
	~Neige();
};

Neige::Neige(int nombre, int width, int height, float speed)
{
	nb = nombre;
	Flakes::SetScreenSize(width, height);
	Flakes::SetSpeed(speed);
	flocons = (Flakes**)malloc(sizeof(Flakes)*nb);
	for(int c=0; c < nb; c++)
		flocons[c] = new Flakes();
}

Neige::~ Neige()
{
	for(int c=0; c<nb; c++)
		delete flocons[c];
}

void Neige::Draw()
{
	glColor3f(1.0,1.0,1.0);
	glBegin(GL_POINTS);
	for(int c=0; c<nb; c++)
		flocons[c]->Draw();
	glEnd();
}

void Neige::Fall()
{
	for(int c=0; c<nb; c++)
		flocons[c]->Move();
		Flakes::fall += 0.05;
	if(Flakes::fall >= 6.0)
		Flakes::fall -= 6.283;
}

void Neige::Add(int nombre)
{
	int tni = nb;
	nb += nombre;
	flocons = (Flakes**)realloc(flocons, sizeof(Flakes)*nb);
	for(int c=tni; c < nb; c++)
		flocons[c] = new Flakes();
}

void Neige::Remove(int nombre)
{
	if(nb >= nombre)
	{
		int tni = nb;
		nb -= nombre;
		for(int c=nb; c < tni; c++)
			delete flocons[c];
		flocons = (Flakes**)realloc(flocons, sizeof(Flakes)*nb);
	}
}
